stages:
  - lint
  - test # needed for security jobs
  - build-image
  - integration-tests
  - release

include:
  - template: Workflows/Branch-Pipelines.gitlab-ci.yml
  - template: Security/SAST.gitlab-ci.yml
  - template: Security/Dependency-Scanning.gitlab-ci.yml
  - template: Security/Secret-Detection.gitlab-ci.yml

shell check:
  image: koalaman/shellcheck-alpine:stable
  stage: lint
  before_script:
    - shellcheck --version
  script:
    - find . -type f -name '*.sh' -exec "shellcheck" {} \;

shfmt:
  image: mvdan/shfmt:v3.7.0-alpine
  stage: lint
  before_script:
    - shfmt -version
  script:
    - find . -type f -name '*.sh' -exec shfmt -i 2 -ci {} \;

build generator:
  stage: build-image
  trigger:
    include: .gitlab/ci/image.gitlab-ci.yml
    strategy: depend
    forward:
      pipeline_variables: true

# Run integration tests
# TODO: Make a mock service instead
generate gitlab-core:
  stage: integration-tests
  trigger:
    include: .gitlab/ci/test.yml
    strategy: depend

create-release:
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  script: echo "Creating release $CI_COMMIT_TAG"
  rules:
    - if: $CI_COMMIT_TAG
  release:
    tag_name: $CI_COMMIT_TAG
    description: "Release $CI_COMMIT_TAG of components in $CI_PROJECT_PATH"
